/**********************************************************
MkDigitImg - takes scanned-in images of sheets that people
wrote in; creates separate files for each box containing a
single handwritten numeral
**********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "Ntadt.h"

#define findX(X, W) ((X<0)? 0 : ((X>(W-1))?(W-1):X))
#define findY(Y, H) findX(Y,H)

#define DIM 12.0	// don't forget .0 !!!

int main(int argc, char *argv[])
{
	char* iterchar;	// to use in _itoa
	
	if (argc<2){
		printf("Usage: MkDigitImg.exe #PAGEIMAGES");
		exit(0);
	}

	
	FILE* coordFile;
	int xCoord, yCoord, numeral, numPgIms, mainLoop, eightBitOut;
	int powerTwo;

	char imageFileName[50];
	/*strcpy(imageFileName,argv[1]);

	char append[3];
	strcpy(append,argv[2]);*/

	numPgIms = atoi(argv[1]);
	
	FILE* dataFile;
	dataFile = fopen("training", "w");
	if (dataFile == NULL){
		printf("Unable to open weight file 'training' for output\n");
		exit(0);
	}

	for (mainLoop=1 ; mainLoop<=numPgIms ; mainLoop++){

		//printf ("hi1");
		
		// File that contains approximate coordinates of digit-boxes
		// in the scanned-in images
		//
		coordFile = fopen("coords.txt","r");
		if(coordFile == NULL){
			printf("\nUnable to open coordinate file coords.txt\n");
			exit(0);
		}
	
		//printf ("hi2");
		
		// The image file to be segmented for this mainLoop iteration
		//
		_itoa(mainLoop,iterchar,10);
		strcpy(imageFileName,"sheetImages\\digitsPage");
		strcat(imageFileName,iterchar);
		strcat(imageFileName,".pbm");

		// Load the image and report errors in case of failure
		//
		BinaryImage imPage=(BinaryImage)imLoad(IMAGE_BINARY, imageFileName);
		if (imPage == (BinaryImage)NULL){
			fprintf(stderr, "can't load image %s\n", imageFileName);
			exit(1);
		}

		int bestFit, bestX, bestY, currentFit;
		int width=imGetWidth(imPage);
		int height=imGetHeight(imPage);
		int x,y,i,j,k;
		char filename[50], append2[2];
		int earliestX, earliestY, latestX, latestY;
		float temp;


		//printf ("hi3");
		
		// This will hold all DIM x DIM images that will get outputted
		// GrayImage currDigit=(GrayImage)imNew(IMAGE_GRAY, DIM, DIM);
		BinaryImage currDigit=(BinaryImage)imNew(IMAGE_BINARY, DIM, DIM);

		while ( (fscanf(coordFile, "%d", &xCoord) != EOF) &&
			(fscanf (coordFile, "%d", &yCoord)!= EOF) &&
			(fscanf (coordFile, "%d", &numeral)!= EOF) &&
			(fscanf (coordFile, "%s", append2) != EOF) ){
			
			
			xCoord*=2; yCoord*=2;	// coords in text file are actually 1/2 what they should be
			bestFit=99999;
			bestX=xCoord;
			bestY=yCoord;
			
			// Search around a 3 x 3 pixel box for the best input box
			//
			
			//printf ("hi4");
			
			for (y=0; y <= 3; y++){
				for (x=0; x <= 3; x++){
					currentFit=0;
					xCoord=xCoord+x;
					yCoord=yCoord+y;
					
					// Make sure entire (34 x 34) box is actually in the image
					//
					if ((findX(xCoord+1,width)==xCoord+1) && 
						(findX(xCoord+34,width)==xCoord+34) && 
						(findY(yCoord+1,height)==yCoord+1) &&
						(findY(yCoord+34,height)==yCoord+34)){
						
						// Add pixel intensity values around the perimiter
						//
						for (i=0; i<34; i++)
							currentFit += imRef(imPage,xCoord+1+i, yCoord+1);	//top line
						for (i=0; i<34; i++)
							currentFit += imRef(imPage,xCoord+1+i, yCoord+34);	//bottom line
						for (i=0; i<34; i++)
							currentFit += imRef(imPage,xCoord+1, yCoord+1+i);	//left line
						for (i=0; i<34; i++)
							currentFit += imRef(imPage,xCoord+34, yCoord+1+i);	//right line
						if (currentFit < bestFit){
							bestFit=currentFit;
							bestX=xCoord+1;
							bestY=yCoord+1;
						}
					}
				}
			}

			//printf ("hi5");

			for (y=-1; y <= -3; y--){
				for (x=-1; x <= -3; x--){
					currentFit=0;
					xCoord=xCoord+x;
					yCoord=yCoord+y;
					
					// Make sure entire (34 x 34) box is actually in the image
					if ((findX(xCoord+1,width)==xCoord+1) && 
						(findX(xCoord+34,width)==xCoord+34) && 
						(findY(yCoord+1,height)==yCoord+1) &&
						(findY(yCoord+34,height)==yCoord+34)){
						for (i=0; i<34; i++)
							currentFit += imRef(imPage,xCoord+1+i, yCoord+1);	//top line
						for (i=0; i<34; i++)
							currentFit += imRef(imPage,xCoord+1+i, yCoord+34); //bottom line
						for (i=0; i<34; i++)
							currentFit += imRef(imPage,xCoord+1, yCoord+1+i);	//left line
						for (i=0; i<34; i++)
							currentFit += imRef(imPage,xCoord+34, yCoord+1+i); //top line
						if (currentFit < bestFit){
							bestFit=currentFit;
							bestX=xCoord+1;
							bestY=yCoord+1;
						}
					}
				}
			}

			//printf ("hi6");
		
			// Search for smallest square box containing intensity values > 0
			earliestX=33;
			latestX=0;
			earliestY=33;
			latestY=0;
			for (y=0; y<34; y++)
				for (x=0; x<34; x++){
					if ( (imRef(imPage,bestX+x,bestY+y) == 1) &&
						(x<earliestX))
						earliestX=x;
					if ( (imRef(imPage,bestX+x,bestY+y) == 1) &&
						(y<earliestY))
						earliestY=y;
					if ( (imRef(imPage,bestX+x,bestY+y) == 1) &&
						(x>latestX))
						latestX=x;
					if ( (imRef(imPage,bestX+x,bestY+y) == 1) &&
						(y>latestY))
						latestY=y;
				}
			
			//printf ("hi7");
			
			int xWidth = latestX - earliestX + 1;
			int yHeight = latestY - earliestY + 1;
			
			// To get DIM x DIM image, use averaging scheme
			// rather than crappy subsampling
			//
			for (y=0; y<DIM; y++)
				for (x=0; x<DIM; x++){
					float startX=bestX+earliestX+x*(xWidth/DIM);
					float startY=bestY+earliestY+y*(yHeight/DIM);
					float endX=startX+(xWidth/DIM);
					float endY=startY+(yHeight/DIM);
					int startXFloor = (int)startX;
					int endXCeil = (endX==(int)endX)? endX : (int)(endX+1);
					int startYFloor = (int)startY;
					int endYCeil = (endY==(int)endY)? endY : (int)(endY+1);

					temp = 0;

					for (j=startYFloor; j<endYCeil; j++)
						for (k=startXFloor; k<endXCeil; k++)
							temp += 255 * imRef(imPage,k,j) * 
								(1-(startX-k>0?startX-k:0)-(k+1-endX>0?k+1-endX:0)) *
								(1-(startY-j>0?startY-j:0)-(j+1-endY>0?j+1-endY:0));
					
					// Compensate for change in brightness
					temp = temp / ((xWidth/DIM)*(yHeight/DIM));

					// Threshold the final (output) pixels
					//imRef(currDigit,x,y)=(int)temp;
					imRef(currDigit,x,y)=(temp>90); //120
				}

			
			powerTwo = 256;
			eightBitOut = 0;

			// Compute 8-bit encoding of every 8 pixels
			for (y=0; y<(int)DIM; y++){
				for (x=0; x<(int)DIM; x++){
					powerTwo /= 2;
					eightBitOut += imRef(currDigit,x,y) * powerTwo;
					if (powerTwo==1){
						fprintf(dataFile,"%x\n", eightBitOut);
						powerTwo = 256;
						eightBitOut = 0;
					}
				}
			}

			if (powerTwo!=(256)){
				printf("Number of pixels in output images must be divisible by 8\n");
				printf("Aborting...");
				exit(0);
			}

			switch (numeral)
			{
				case 0:
					strcpy (filename, "zeros\\");	// "\\" is the escape sequence for "\"
					
					// implement expected output encoding of digit as 4 floats
					// representing 4 bits
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);

						break;
				case 1:
					strcpy (filename, "DigitImages\\ones\\");
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 1.0);
						break;
				case 2:
					strcpy (filename, "DigitImages\\twos\\");
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 1.0);
					fprintf(dataFile, "%f\n", 0.0);
						break;
				case 3:
					strcpy (filename, "DigitImages\\threes\\");
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 1.0);
					fprintf(dataFile, "%f\n", 1.0);
						break;
				case 4:
					strcpy (filename, "DigitImages\\fours\\");
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 1.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);
						break;
				case 5:
					strcpy (filename, "DigitImages\\fives\\");
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 1.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 1.0);
						break;
				case 6:
					strcpy (filename, "DigitImages\\sixes\\");
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 1.0);
					fprintf(dataFile, "%f\n", 1.0);
					fprintf(dataFile, "%f\n", 0.0);
						break;
				case 7:
					strcpy (filename, "DigitImages\\sevens\\");
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 1.0);
					fprintf(dataFile, "%f\n", 1.0);
					fprintf(dataFile, "%f\n", 1.0);
						break;
				case 8:
					strcpy (filename, "DigitImages\\eights\\");
					fprintf(dataFile, "%f\n", 1.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);
						break;
				case 9:
					strcpy (filename, "DigitImages\\nines\\");
					fprintf(dataFile, "%f\n", 1.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 0.0);
					fprintf(dataFile, "%f\n", 1.0);
						break;
				default:
					printf("coord file is fucked up!\n");
			}
				
			//printf ("hi9");
			
			strcat(filename,iterchar);
			strcat(filename,append2);
			strcat(filename,".pgm");
				
			imSave(currDigit,filename);
		}

		printf("\nFinished segmenting file %s",imageFileName);
		mainLoop = atoi(iterchar);	// This is a total kludge - "itoa" CHANGES its first arg (!?)

	}

	printf("\nDone!\n");
	fclose(dataFile);
	fclose(coordFile);

	return 0;
}

