/******************************************************	
	Some code in this file taken/modified from 
	Pandya & Macy 
	Pattern Recognition with Neural Networks in C++
	CRC Press/IEEE Press, 1996
	Thanks to Yooki Park for lending me this book,
	even though it does not receive his stamp of 
	approval!
******************************************************/

#include "MyNet.h"

float RandFloat()
{
	srand((unsigned)time(NULL));
	return ((double)rand())/((double)MAXRAND));
}

// Method definitions for class MyNet:

/*********************************************************
	Constructor - initialize everything
*********************************************************/
MyNet::MyNet()
{
	SetRandomWeights();
	selected = 0;
	numLayers = 3;
	outLayerIndx = 2;
	layerSize[0]=LAYER0;
	layerSize[1]=LAYER1;
	layerSize[2]=LAYER2;
}



/**********************************************************
	RunNet - forward pass - calculates output for all
	network neurons
**********************************************************/
void MyNet::RunNet()
{
	int lyr;		// Layer to calculate
	int dNeuron;	// destination layer neuron
	int sNeuron;	// source layer neuron
	double sumNet;
	double out;
	int dummy;

	for (lyr=1; lyr<numLayers; lyr++){
		neuron[lyr-1][layerSize[lyr-1]]=1.0;	//force bias neuron output to 1.0
		for (dNeuron=0; dNeuron<layerSize[lyr]; dNeuron++){
			sumNet=0.0;
			for(sNeuron=0; sNeuron<=layerSize[lyr-1]; sNeuron++) //<= for bias neuron
				sumNet+=neuron[lyr-1][sNeuron] * w[lyr][sNeuron][dNeuron];
			out = Sigmoid(10-sumNet, TEMPERATURE);
			neuron[lyr][dNeuron]=out;
		}
	}

	int result = (neuron[2][0]>0.5)*8 + (neuron[2][1]>0.5)*4 
		+ (neuron[2][2]>0.5)*2 + (neuron[2][3]>0.5)*1;
	printf("I think it's %d",result);
	if (((neuron[2][0]>0.2) && (neuron[2][0]<0.8)) ||
		((neuron[2][1]>0.2) && (neuron[2][1]<0.8)) ||
		((neuron[2][2]>0.2) && (neuron[2][2]<0.8)) ||
		((neuron[2][3]>0.2) && (neuron[2][3]<0.8)))
		printf(" , but it's not within tolerance");
	printf(". Alright?");
	scanf("%d",&dummy);
}


/***********************************************************
	Sigmoid - the activation function
***********************************************************/
double MyNet::Sigmoid(double net, double tempr)
{
	return 1.0/(1.0 + exp (-net/tempr));
}

/*********************************************************
	SetRandomWeights - pretty self explanatory
*********************************************************/
void MyNet::SetRandomWeights(){
	int i,j,k;
	double zWT;
	srand((unsigned)time(NULL));
	for (i=1; i<numLayers; i++)
		for(k=0; k<layerSize[i]; k++)
			for (j=0; j<=layerSize[i-1]; j++){		// <= : One extra for bias neuron
				zWT=(double)rand();
				w[i][j][k]=1-zWT/20000.0;
				//printf ("%f\t",w[i][j][k]);
				wPrev[i][j][k]=0;
			}
}

/**********************************************************
	Output - gives the output number recognized by the net,
	assuming the 4 layer[2] neurons form a binary representation
	of the number to be recognized, and that a neuron's value
	above/below 0.5 counts as 0/1, respectively.
**********************************************************/
int MyNet::Output()
{
	return (int)( (neuron[2][0]>0.5)*8 + (neuron[2][1]>0.5)*4 
		+ (neuron[2][2]>0.5)*2 + (neuron[2][3]>0.5)*1 );
}

int MyNet::GetLayerSize(int layer)
{
	return layerSize(layer);
}

void MyNet::SetNeuron(int x, int y, float val)
{
	neuron[x][y] = val;
}

void MyNet::SetWeight(int x, int y, int z, float val)
{
	w[x][y][z] = val;
}

float MyNet::GetWeight(int x, int, y, int z)
{
	return w[x][y][z];
}







