#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define MAX_RAND 2000

#define MAXLAYERS 3				// Max # of layers in net (in, out, & hidden)
#define MAXNEURONS 150			// Max # of neurons per layer
#define TRUE 1
#define FALSE 0	
#define TEMPERATURE 1
#define LAYER0 145
#define LAYER1 145
#define LAYER2 4				

class MyNet {
private:
	double w[MAXLAYERS][MAXNEURONS][MAXNEURONS];		// Weights matrix
	double neuron[MAXLAYERS][MAXNEURONS];
	double error[MAXNEURONS];
	
	//Topology
	//
	int numLayers;				// # of layers
	int outLayerIndx;			// array index of last layer
	int layerSize[MAXLAYERS];	// Number of neurons in each layer

	//Pattern Data
	//
	double desired[MAXNEURONS];	// Desired value for each pattern/output
	
public:
	MyNet(void);
	void RunNet(void);
	double Sigmoid(double, double);
	void SetRandomWeights(void);
	int Output();
	int GetLayerSize(int);
	void SetNeuron(int,int,float);
	void SetWeight(int, int, int, float);
	float GetWeight(int, int, int);

	char selected; //selected to be a parent
	
};

