/******************************************************	
	Code in this file taken from Pandya & Macy, 
	Pattern Recognition with Neural Networks in C++
	CRC Press/IEEE Press, 1996
	Thanks to Yooki Park for lending me this book,
	even though it does not receive his stamp of 
	approval!
******************************************************/



#define NEURONHIGH 1.0		// Neuron's high output value
#define NEURONLOW 0.0		// Neuron's low output value
#define TRUE 1
#define FALSE 0

class Weight				// Forward reference

struct	WeightImage{
	double data;			// Weight value
	int sneuron;			// Source neuron for this weight
	int dneuron;			// Destination neuron for this weight
	WeightImage* next;
};

class NetResults{
	int index;				// Neuron's identification number
	double value;			// Neuron's output value
	char character;			// Character representation of digit
};

class NetFileData{
private:
	double temperature;		// Neuron's temperature
	double threshold;		// Neuron's firing threshold
	int nLayers;			// Number of layers in the net
	int neurons[MAXLAYERS];	// Number of neurons per layer
	int status;				// Error status (0: OK)
	WeightImage* weights[MAXLAYERS-1];	//Temporary weight storage area
	void AddWeights(int l, int d, int s, double w);
	double GetWeights(int l, int d, int s);

public:
	NetFileData(void);
	int SetupNet(char*);
	double GetTemp(void) 
		{return temperature;}
	double GetThresh(void) 
		{return threshold;}
	int GetNLayers(void) 
		{return nLayers;}
	int GetLayerSize(int layer)
		{return neurons[layer];}
	double GetWeight(int l, int d, int s)
		{return GetWeights(l-1, d, s);}
	int GetStatus(void)
		{return status;}
};

	

