#ifndef _DXwindow_
#define _DXwindow_


#include "NTadt.h"
#include <ddraw.h>
#include "..\rtvideo.h"


#define DRX_DRAW_UP 0
#define DRX_DRAW_DOWN 1

#ifdef __cplusplus 
extern "C" {            /* Assume C declarations for C++ */ 
#endif/* __cplusplus */ 

typedef struct{
	HWND hwnd;
	int numWindows;
	LPDIRECTDRAW lpDD;
	LPDIRECTDRAWSURFACE lpDDSPrimary;// DirectDraw primary surface 
	LPDIRECTDRAWCLIPPER lpDDClipper;
	HANDLE	hThread;
	HANDLE createdEv;
} drX_cookie;

typedef struct{
	HWND hwnd;
	DWORD dwWidth;
	DWORD dwHeight;
	drX_cookie *mCookie;
	LPDIRECTDRAWSURFACE lpDDSOne;// Offscreen surface 1 
	DWORD dwFlags;
	CRITICAL_SECTION critSec;
	char *title;
} drX_windowCookie;

typedef void (* pfnInnerBlt) (UCHAR *curPointerBuf, int lineOffsetBuf, 
															DWORD format, void *imCookie);


RTV_DECL int
drX_closeWindow(drX_windowCookie *cookie);

RTV_DECL int
drX_close(drX_cookie *cookie);

RTV_DECL drX_windowCookie*
drX_createWindow(drX_cookie *mCookie,
		DWORD dwWidth, DWORD dwHeight, char *title);

RTV_DECL int
drX_forceBltGen(drX_windowCookie *cookie, 
								pfnInnerBlt innerBlt,
								void *imCookie,
								DWORD imWidth,
								DWORD imHeight,
								int orientation);

RTV_DECL void
BltRGB(UCHAR *curPointerBuf, 
			 int lineOffsetBuf, 
			 DWORD format, 
			 void *imCookie);

RTV_DECL void
BltBinary(UCHAR *curPointerBuf, 
			 int lineOffsetBuf, 
			 DWORD format, 
			 void *imCookie);

RTV_DECL void
BltGray(UCHAR *curPointerBuf, 
			 int lineOffsetBuf, 
			 DWORD format, 
			 void *imCookie);

RTV_DECL void
BltFloat(UCHAR *curPointerBuf, 
			 int lineOffsetBuf, 
			 DWORD format, 
			 void *imCookie);



#define drX_forceBltRGB(cookie, im) \
	(drX_forceBltGen((cookie), &BltRGB, (void *)(im), \
									imGetWidth(im), imGetHeight(im), \
									DRX_DRAW_UP))

#define drX_forceBltBinary(cookie, im) \
	(drX_forceBltGen((cookie), &BltBinary, (void *)(im), \
									imGetWidth(im), imGetHeight(im), \
									DRX_DRAW_UP))

#define drX_forceBltGray(cookie, im) \
	(drX_forceBltGen((cookie), &BltGray, (void *)(im), \
									imGetWidth(im), imGetHeight(im), \
									DRX_DRAW_UP))


// the userdata ptr should point to two floats, the first of them the max value and the second the
// minimum value of the float you want to blat
#define drX_forceBltFloat(cookie, im) \
	(drX_forceBltGen((cookie), &BltFloat, (void *)(im), \
									imGetWidth(im), imGetHeight(im), \
									DRX_DRAW_UP))


RTV_DECL int
drX_forceBltBuf(drX_windowCookie *cookie, RTVVIDEOHDR *videoHdr,
								BITMAPINFOHEADER *bmih);

RTV_DECL drX_cookie*
drX_init(VOID);

#ifdef __cplusplus 
} 
#endif/* __cplusplus */

#endif