#ifndef GRAB_H
#define GRAB_H

#include "..\rtvideo.h"

typedef struct {
	HANDLE hDriver;
	RTVVIDEOHDR *videoHdr;				// pointer to big memory block where the videoHdrs live
	RTVVIDEOHDR **videoHdrQueue;
	volatile int firstDone;			// pointers to videoHdrQueue
	volatile int firstNotDone;
	int num_bufs;					// size of videoHdrQueue
	int cache_size;					
	RTVVIDEOHDR **extraVideoHdr;
	int extraFirst;					// pointers to extraVideoHdr
	int extraLast;
	int extraEmpty;
	int num_user_bufs;				// size of extraVideoHdr
	int sleepTime;					// in milliseconds
	int userDropped;
	CRITICAL_SECTION criticalSection;
	volatile DWORD dwFlags;
	HANDLE hThread;
} grab_cookie;

#define GRAB_CAPTURING		0x1

RTV_DECL int
grab_startStream(grab_cookie *cookie);

RTV_DECL int
grab_stopStream(grab_cookie *cookie);

RTV_DECL void
grab_returnStreamFrame(grab_cookie *cookie, RTVVIDEOHDR *videoHdr);

RTV_DECL RTVVIDEOHDR *
grab_getStreamFrame(grab_cookie *cookie);

RTV_DECL int
grab_initStream(grab_cookie *cookie, int fps, int num_bufs, int cache_size, int num_user_bufs);

RTV_DECL int
grab_closeStream(grab_cookie *cookie);

RTV_DECL grab_cookie *
grab_init();

RTV_DECL int
grab_close(grab_cookie *cookie);

RTV_DECL int
grab_formatDialog(grab_cookie *cookie);

RTV_DECL RTVVIDEOHDR *
grab_getFrame(grab_cookie *cookie);

RTV_DECL BITMAPINFOHEADER *
grab_getFormat(grab_cookie *cookie);


#endif